/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/loggie-io/loggie/pkg/discovery/kubernetes/apis/loggie/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeVms implements VmInterface
type FakeVms struct {
	Fake *FakeLoggieV1beta1
}

var vmsResource = schema.GroupVersionResource{Group: "loggie.io", Version: "v1beta1", Resource: "vms"}

var vmsKind = schema.GroupVersionKind{Group: "loggie.io", Version: "v1beta1", Kind: "Vm"}

// Get takes name of the vm, and returns the corresponding vm object, and an error if there is any.
func (c *FakeVms) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.Vm, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(vmsResource, name), &v1beta1.Vm{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.Vm), err
}

// List takes label and field selectors, and returns the list of Vms that match those selectors.
func (c *FakeVms) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.VmList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(vmsResource, vmsKind, opts), &v1beta1.VmList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.VmList{ListMeta: obj.(*v1beta1.VmList).ListMeta}
	for _, item := range obj.(*v1beta1.VmList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested vms.
func (c *FakeVms) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(vmsResource, opts))
}

// Create takes the representation of a vm and creates it.  Returns the server's representation of the vm, and an error, if there is any.
func (c *FakeVms) Create(ctx context.Context, vm *v1beta1.Vm, opts v1.CreateOptions) (result *v1beta1.Vm, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(vmsResource, vm), &v1beta1.Vm{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.Vm), err
}

// Update takes the representation of a vm and updates it. Returns the server's representation of the vm, and an error, if there is any.
func (c *FakeVms) Update(ctx context.Context, vm *v1beta1.Vm, opts v1.UpdateOptions) (result *v1beta1.Vm, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(vmsResource, vm), &v1beta1.Vm{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.Vm), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeVms) UpdateStatus(ctx context.Context, vm *v1beta1.Vm, opts v1.UpdateOptions) (*v1beta1.Vm, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(vmsResource, "status", vm), &v1beta1.Vm{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.Vm), err
}

// Delete takes name of the vm and deletes it. Returns an error if one occurs.
func (c *FakeVms) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(vmsResource, name, opts), &v1beta1.Vm{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeVms) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(vmsResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.VmList{})
	return err
}

// Patch applies the patch and returns the patched vm.
func (c *FakeVms) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.Vm, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(vmsResource, name, pt, data, subresources...), &v1beta1.Vm{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.Vm), err
}
