/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by lister-gen. DO NOT EDIT.

package v1beta1

import (
	v1beta1 "github.com/loggie-io/loggie/pkg/discovery/kubernetes/apis/loggie/v1beta1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// VmLister helps list Vms.
// All objects returned here must be treated as read-only.
type VmLister interface {
	// List lists all Vms in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.Vm, err error)
	// Get retrieves the Vm from the index for a given name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta1.Vm, error)
	VmListerExpansion
}

// vmLister implements the VmLister interface.
type vmLister struct {
	indexer cache.Indexer
}

// NewVmLister returns a new VmLister.
func NewVmLister(indexer cache.Indexer) VmLister {
	return &vmLister{indexer: indexer}
}

// List lists all Vms in the indexer.
func (s *vmLister) List(selector labels.Selector) (ret []*v1beta1.Vm, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.Vm))
	})
	return ret, err
}

// Get retrieves the Vm from the index for a given name.
func (s *vmLister) Get(name string) (*v1beta1.Vm, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta1.Resource("vm"), name)
	}
	return obj.(*v1beta1.Vm), nil
}
